/*
	dskbench v0.44 for X680x0  by Ⴌ゠

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>


#define		TESTTIME	(5)

int		CommandRank[ 3 ] = { 25, 35, 160 };
int		SeekRank[ 2 ] = { 100, 400 };
int		ReadRank[ 3 ][ 3 ] =
		{
			{ 5120, 60000, 60000 },
			{ 5120, 60000, 60000 },
			{  400, 10000, 30000 }
		};

#define		DISP_SIZE	(8+16+4)
#define		DPB_SIZE	(94)

typedef		unsigned long long int	ullint;
typedef		unsigned short			ushort;

typedef		struct
			{
				ushort	byte;
				char	sect;
				ushort	clust;
			} TDPB_T;

typedef		struct
			{
				int		lba;
				int		byte;
			} READCAP_T;

typedef		struct
			{
				char	DeviceType;
				char	RMB;
				char	ANSI_Ver;
				char	RDF;
				char	AddLen;
				char	RESV0;
				char	RESV1;
				char	OptFunc;
				char	VendorID[8];
				char	ProductID[16];
				char	FirmRev[4];
			} INQUIRY_T;

typedef		struct
			{
				char	code;
				char	seg_no;
				char	key;
				char	info[4];
				char	addlen;
				char	csinfo[4];
				char	asc;
				char	ascq;
				char	fruc;
				char	ssinfo[3];
			} REQUEST_T;


char	dataBuf[65536];
int		MPU, PortType, SCSIver;
int		TargetID, LbaMax, SectSize;

char	*bar = "------------------------+-------------+-------+-------+-------+-------+-------+";
char	*bar2= "-------------------------------------------------------------------------------";

char	*XO[] = { "~" , "" };

char	*Device[] =
		{
			"Direct access",
			"Sequential access",
			"Printer",
			"Processor",
			"Write once",
			"CD-ROM",
			"Scanner",
			"Optical memory",
			"Medium changer",
			"Communications",
		};

char	*ANSI_VS[] =
		{
			"Not ANSI",
			"SCSI1",
			"SCSI2",
			"SCSI3"		// E\Ȃ
		};

char	*RDFS[] =
		{
			"SCSI1",
			"CCS",
			"SCSI2",
			"SCSI3"		// E\Ȃ
		};

char	*FuncS[] =
		{
			"Relative addressing      ",
			"32bit wide data transfer ",
			"16bit wide data transfer ",
			"Synchronous data transfer",
			"Linked command           ",
			"",
			"Command queuing          ",
			"Soft reset condition     "
		};

char	*SCSIPort[] =
		{
			"SCSI-Port",
			"SCSI-Board",
			"Other-Port"
		};

#define		MPUTYPE		(char *)0x00000CBC
#define		SASIFLAG	(char *)0x00ED0071

int		__DOSCALL	CHGDRV(short drv);
int		__DOSCALL	CURDRV(void);
int		__DOSCALL	GETDPB(short drv, void *buf);
void	__DOSCALL	DISKRED(void *buf, short drv, int pos, int len);
int		__DOSCALL	GETENV(const char *name, char *env, char *buf);

int	S_INQUIRY(int len, int id, void *buf);
int	S_TESTUNIT(int id );
int	S_READCAP(int id, void *buf);
int	S_READEXT(int lba, int blen, int id, int bsize, void *buf);
int	S_REQUEST(int len, int id, void *buf);
int	S_SEEKEXT(int lba, int id);
int	S_VERSION(void);
int	S_VERIFY(int lba, int blen, int id);

#include <scsi_macro.inc>
#undef	S_SEEKEXT
#undef	S_VERIFY

int		check_spc(void);


#define B_BPEEK( addr )										\
({															\
	register long  _d0 __asm("d0");							\
	register void *_a1 __asm("a1");							\
	_a1 = (addr);											\
	__asm __volatile( "moveq #$82,%0\n\t"					\
					  "trap #15"							\
					: "=d"(_d0)								\
					: "a"(_a1)								\
					: "d0","a1" );							\
	_d0;													\
})


/******************************************************************

	o[̕\

*******************************************************************/
void	DispBarGraph(int rank)
{
	int		k;

	for( k = 0 ; k < rank ; k++ )
		putchar( '*' );
	putchar( '\n' );
}


/******************************************************************

	CjVG[^ϐ瓾i

*******************************************************************/
void	GetInitiatorName(char *buf)
{
	char	getbuf[256];

	memset(buf, 0x20, 16);
	if(GETENV("Initiator", 0, getbuf) < 0)
		sprintf(getbuf, "X680%X0", MPU);
	strncpy(buf, getbuf, strlen(getbuf));
	buf[16] = '\0';
}


/******************************************************************

	ݎgpĂ{̂̂hc𓾂

*******************************************************************/
int		GetSPC_ID(void)
{
	int		res;

	res = check_spc();
	PortType = (res>>16) & 0x0f;
	return (res & 0b111);
}


/******************************************************************

	G[\ďI

*******************************************************************/
__volatile	void	error_exit(const char *msg)
{
	fprintf( stderr, "%s\n" , msg );
	exit(-1);
}


/******************************************************************

		Xe[^X

*******************************************************************/
int		check_result(int statmsg)
{
	int		res = 0;
	int		stat;
	REQUEST_T	sense;

	if( statmsg != 0 )
	{
		if( statmsg < 0 )
			error_exit( "IOCS Undefined error" );
		stat = statmsg & 0b11111_0;
		switch( stat )
		{
			case 0b00000_0:		// good
					break;
			default:			// check condition and others
					if( S_REQUEST( sizeof(REQUEST_T) , TargetID , &sense ) < 0 )
						error_exit( "failed:REQUEST SENSE" );
					fprintf( stderr , "status:%02X key:%02X asc:%02X ascq:%02X\n" ,
										stat , sense.key , sense.asc , sense.ascq );
					res = -1;
		}
	}
	return res;
}


/******************************************************************

	rbrhR}hEx`}[N

	R}h̎sԂv

*******************************************************************/
int		CommandBench(void)
{
	int		rank, k, count, mode, BlkSize;
	time_t	stt;
	static	char	*ModeMes[] =
	{
		"Test unit ready command" ,
		"No motion seek command ",
		"Average latency Time   "
	};

	BlkSize = SectSize >> 9;
	puts( bar );
	for( mode = 0 ; mode != 3 ; ++mode )
	{
		printf( "%s |" , ModeMes[mode] );
		fflush( stdout );
		if( check_result(S_SEEKEXT( 0 , TargetID )) != 0 )
			error_exit("failed:SEEK(10)");
		count = 0;
		stt = time(NULL);
		while( stt == time(NULL) )
			;
		stt += TESTTIME + 1;
		while( time(NULL) < stt )
		{
			switch( mode )
			{
				case 0:
					for( k = 100 ; k != 0 ; --k )
						if( check_result(S_TESTUNIT( TargetID )) != 0 )
							error_exit("failed:TESTUNIT");
					count += 100;
					break;
				case 1:
					for( k = 100 ; k != 0 ; --k )
						if( check_result(S_SEEKEXT( 0 , TargetID )) != 0 )
							error_exit("failed:SEEK(10)");
					count += 100;
					break;
				case 2:
					if( check_result(S_VERIFY( 0 , 1 , TargetID )) != 0 )
					{
						printf("failed:VERIFY\n");	// G[łp
						return(-1);
					}
					count += 2;
					break;
			}
		}
		count = TESTTIME * 10000 / count;
		printf( "  %3d.%1d[ms]  :" , count / 10 , count % 10 );
		rank = ( CommandRank[ mode ] - count ) * 40 / CommandRank[ mode ] + 1;
		DispBarGraph(rank);
	}
	return 0;
}


/******************************************************************

	V[NEx`}[NeXg

	V[PVV[Nƃ_V[N̎sԂv

*******************************************************************/
int		SeekBench(void)
{
	int		rank, count, mode;
	int		SeekPos, RndScl;
	time_t	stt;
	static	char	*ModeMes[] =
	{
		"Sequential seek command",
		"Random seek command    "
	};

	RndScl = LbaMax / 32767;
	if( RndScl == 0 )
		RndScl = 1;
	puts( bar );
	for( mode = 0 ; mode != 2 ; ++mode )
	{
		SeekPos = 0;
		if( check_result(S_SEEKEXT( 0 , TargetID )) != 0 )
			error_exit("failed:SEEK(10)");
		printf( "%s |" , ModeMes[mode] );
		fflush( stdout );
		count = 0;
		stt = time(NULL);
		while( stt == time(NULL) )
			;
		stt += TESTTIME + 1;
		while( time(NULL) < stt )
		{
			if( check_result(S_SEEKEXT( SeekPos , TargetID )) != 0 )
				error_exit("failed:SEEK(10)");
			switch( mode )
			{
				case 0:
					SeekPos += 32;
					if( SeekPos > LbaMax )
						SeekPos = 0;
					break;
				case 1:
					do
					{
						SeekPos = rand() * RndScl;
					} while( SeekPos > LbaMax );
					break;
			}
			count++;
		}
		count = TESTTIME * 10000 / count;
		printf( "  %3d.%1d[ms]  :" , count / 10 , count % 10 );
		rank = ( SeekRank[ mode ] - count ) * 40 / SeekRank[ mode ] + 1;
		DispBarGraph(rank);
	}
	return 0;
}


/******************************************************************

	[hEx`}[NeXg

	V[PV[hƃ_[h̎sԂv

*******************************************************************/
int		ReadBench(void)
{
	int		rank, count, mode, benchCount;
	int		RdPos, RdBlk, RdBlkMax, BlkSize, RndScl, RndMax, startAddr;
	time_t	stt;
	static	char *ModeMes[] =
	{
		"Seq.Read/Start",
		"Seq.Read/ End ",
		"Random  Read  "
	};

	BlkSize = SectSize >> 9;
	RndScl = ( LbaMax - 65536 / SectSize ) / 32767;
	if( RndScl <= 0 )
		RndScl = 1;
	RdBlkMax = 65536 / SectSize;
	for( mode = 0 ; mode != 3 ; ++mode )
	{
		puts( bar );
		for( benchCount = 0, RdBlk = 1 ; benchCount < 3; ++benchCount )
		{
			if(mode == 1)
			{
				startAddr = LbaMax - 20480;		// 10MB from inner
				if(startAddr < 0)
					startAddr = 0;
			}
			else
				startAddr = 0;
			RdPos = startAddr;
			if( check_result(S_SEEKEXT( RdPos , TargetID )) != 0 )
				error_exit("failed:SEEK(10)");
			printf( "%s %5dB/rd|" , ModeMes[mode] , RdBlk * SectSize );
			fflush( stdout );
			RndMax = LbaMax - RdBlk;
			count = 0;
			stt = time(NULL);
			while( stt == time(NULL) )
				;
			stt += TESTTIME + 1;
			while( time(NULL) < stt )
			{
				if( check_result(S_READEXT( RdPos , RdBlk , TargetID , BlkSize , dataBuf )) != 0 )
					error_exit("failed:READ(10)");
				switch( mode )
				{
					case 0:
					case 1:
						RdPos += RdBlk;
						if( RdPos >= LbaMax )
							RdPos = startAddr;
						break;
					case 2:
						do
						{
							RdPos = rand() * RndScl;
						} while( RdPos > LbaMax );
						break;
				}
				count += RdBlk;
			}
			count = count * 10 * SectSize / TESTTIME / 1024;
			printf( " %4d.%1d[KB/s]:" , count / 10 , count % 10 );
			rank = count * 40 / ReadRank[ mode ][ benchCount ] + 1;
			if( rank > 40 )
				rank = 40;
			DispBarGraph(rank);
			switch( benchCount )
			{
				case 0:
					RdBlk = 16384 / SectSize;
					break;
				case 1:
					RdBlk = RdBlkMax;
					break;
				default:
					break;
			}
		}
	}
	return 0;
}


/******************************************************************

	cnrR[ł̃[hx`}[N

	V[PV[hƃ_[h̎sԂv

*******************************************************************/
void	DskReadBench(int drive, TDPB_T *dpb)
{
	int		count, 	mode;
	int		RdPos, RdBlk, RdBlkMax, SectMax, RndScl, RndMax;
	char	*Bufaddr;
	time_t	stt;
	static	char	*ModeMes[] =
	{
		"Seq. read",
		"Rnd. read"
	};
	char	*bar = "------------------------+--------------";

	Bufaddr = dataBuf + 0x80000000;		// CȎdl
	SectMax = ( dpb->clust - 1 ) * ( dpb->sect + 1 );
	RndScl = ( SectMax - 65536 / dpb->byte ) / 32767;
	if( RndScl == 0 )
		RndScl = 1;
	RdBlkMax = 65536 / dpb->byte;
	printf( "ZN^ %d  PZN^ %d oCg\n" , SectMax , dpb->byte );
	for( mode = 0 ; mode != 2 ; mode++ )
	{
		puts( bar );
		for( RdBlk = 1024 / dpb->byte ; ; )
		{
			printf( " %s  %5dB/read |" , ModeMes[mode] , RdBlk * dpb->byte );
			fflush( stdout );
			RdPos = 0;
			DISKRED( Bufaddr , drive , RdPos , RdBlk );
			RndMax = SectMax - RdBlk;
			count = 0;
			stt = time(NULL);
			while( stt == time(NULL) )
				;
			stt += TESTTIME + 1;
			while( time(NULL) < stt )
			{
				DISKRED( Bufaddr , drive , RdPos , RdBlk );
				switch( mode )
				{
					case 0:
						RdPos += RdBlk;
						if( RdPos > RndMax )
							RdPos = 0;
						break;
					case 1:
						do
						{
							RdPos = rand() * RndScl;
						} while( RdPos > RndMax );
						break;
				}
				count += RdBlk;
			}
			count = count * 10 * dpb->byte / TESTTIME / 1024;
			printf( " %4d.%1d[KB/s]\n" , count / 10 , count % 10 );
			if( RdBlk == ( 1024 / dpb->byte ) )
				RdBlk = 16384 / dpb->byte;
			else if( RdBlk != RdBlkMax )
				RdBlk = RdBlkMax;
			else
				break;
		}
	}
	puts( bar );
}


/******************************************************************

		CƂ[

*******************************************************************/
void	main(int argc , char *argv[])
{
	ullint	size64;
	int		SPC_ID, TargetDRV;
	int		CurDRV, TmpDRV, Res;
	int		loop, sbit;
	char	tbf[DISP_SIZE+1];
	char	dpb_buf[DPB_SIZE];
	TDPB_T		dpb;
	REQUEST_T	sense;
	INQUIRY_T	inq;
	READCAP_T	capa;
	char	machine_name[16+1];

	printf( "X680x0 DISK benchmark version 0.44 by bisco\n" );
	printf( "Original program:" );
	printf( "\nASPI SCSI benchmark test V0.4 \n" );
	printf( " copyright(c) by TsuruZoh Tachibanaya, Sep.02,1994\n\n" );

	MPU = B_BPEEK(MPUTYPE) & 0xf;
	SPC_ID = GetSPC_ID() & 0b111;
	SCSIver = S_VERSION() & 0xffff;
	GetInitiatorName( machine_name );
	if( argc == 1 )
	{
		tbf[DISP_SIZE] = '\0';
		for( TargetID = 0 ; TargetID <= 7 ; TargetID++ )
		{
			printf( "ID%d:" , TargetID );
			fflush( stdout );
			if( TargetID == SPC_ID )
				printf("SHARP   %s%04X  %s\n" , machine_name ,SCSIver, SCSIPort[PortType] );
			else
			{
				inq.RMB = 0;
				memset( tbf , '-' , DISP_SIZE );
				if( 0 <= S_INQUIRY( sizeof(INQUIRY_T) , TargetID , &inq ) )
					memcpy( tbf , inq.VendorID , DISP_SIZE );
				printf( "%s", tbf);
				if( ( inq.RMB & 0x80 ) != 0 )
					printf( "  Removable" );
				putchar( '\n' );
			}
		}
	}
	else if( argc == 2 )
	{
		if( strlen(argv[1]) == 2 && isalpha(argv[1][0]) != 0 && argv[1][1] == ':' )
		{
			TargetDRV = toupper( *argv[1] ) - 'A';
			CurDRV = CURDRV();
			TmpDRV = CHGDRV( TargetDRV );
			CHGDRV( CurDRV );
			Res = GETDPB( TargetDRV+1 , dpb_buf );
			if( Res < 0 && TmpDRV > TargetDRV )
				error_exit( "hCȗu񂪑݂܂B" );
			else if( Res < 0 )
				error_exit( "zhCułB" );
			dpb.byte  = (dpb_buf[2]<<8) | dpb_buf[3];
			dpb.sect  = dpb_buf[4];
			dpb.clust = (dpb_buf[14]<<8) | dpb_buf[15];
			if( dpb.byte > 2048 )
				error_exit( "ZN^TCYT|[g͈͊OłB" );
			DskReadBench( TargetDRV+1 , &dpb );
		}
		else
		{
			if( isdigit( argv[1][0] ) == 0 &&
				( strlen( argv[1] ) == 1 || strlen( argv[1] ) == 2 && toupper(argv[1][1]) == 'I') )
				error_exit( "hc͂P̐łB" );
			TargetID = atoi(argv[1]);
			if( TargetID < 0 || 7 < TargetID )
				error_exit( "hc͂O`V͈̔͂łB" );
			if( TargetID == SPC_ID )
				error_exit( "ŵhc͎gp̖{̂̂̂łB" );
			if( ( B_BPEEK(SASIFLAG) >> TargetID ) & 0b1 != 0 )
				error_exit( "ŵhc͂r`rhŎgpĂ܂B" );
			if( S_TESTUNIT( TargetID ) == -1 )
				error_exit( "whc̃foCX̓ANZXoȂ悤łB" );
			if( S_REQUEST( sizeof(REQUEST_T) , TargetID , &sense ) < 0 )	// dummy sense
				error_exit( "failed:REQUEST SENSE" );
			if( check_result(S_INQUIRY( sizeof(INQUIRY_T) , TargetID , &inq )) != 0 )
				error_exit("failed:INQUIRY");
			if( toupper(argv[1][1]) == 'I' )
			{
				puts( bar2 );
				printf( "Device code             : " );
				if( inq.DeviceType <= 0x0b )
					printf( "%s device" , Device[inq.DeviceType] );
				else
				{
					if(inq.DeviceType == 0x10)
						printf( "MiniDisc" );
					else
						printf( "Undefined" );
				}
				if( ( inq.RMB & 0x80 ) != 0 )
					printf( "...Removable" );
				printf( "\nANSI approved version   : %s\n" , inq.ANSI_Ver <= 3 ? ANSI_VS[inq.ANSI_Ver] : "Unknown" );
				printf( "Responce data format    : %s\n" , inq.RDF <= 3 ? RDFS[inq.RDF] : "Unknown" );
				printf( "Additional length       : %dbytes\n" , inq.AddLen );
				strncpy( tbf , inq.VendorID , sizeof( inq.VendorID ) );
				*(tbf + sizeof( inq.VendorID ) ) = '\0';
				printf( "Vendor identification   : %s\n" , tbf );
				strncpy( tbf , inq.ProductID , sizeof( inq.ProductID ) );
				*(tbf + sizeof( inq.ProductID ) ) = '\0';
				printf( "Product identification  : %s\n" , tbf );
				strncpy( tbf , inq.FirmRev , sizeof(inq.FirmRev) );
				*(tbf + sizeof( inq.FirmRev ) ) = '\0';
				printf( "Product revision level  : %s\n" , tbf );
				puts( bar2 );
				printf( "Optional function support\n" );
				printf( "ATN receive(processor device only) : %s\n" , XO[(inq.RDF >> 7) & 0b1] );
				printf( "Terminate I/O process message      : %s\n" , XO[(inq.RDF >> 6) & 0b1] );
				for( loop = 0 , sbit = 7 ; 0 <= sbit ; ++loop , --sbit )
				{
					if( sbit != 2 )
						printf( "%s          : %s\n" , FuncS[loop] , XO[(inq.OptFunc >> sbit) & 0b1] );
				}
				puts( bar2 );
				if( check_result(S_READCAP( TargetID , &capa )) != 0 )
					error_exit("failed:READ CAPACITY");
				if( capa.lba != 0 )
					capa.lba++;
				printf( "Number of Logical block address : %d Blocks\n" , capa.lba );
				printf( "Block length                    : %d Bytes\n" , capa.byte );
				size64 = (ullint)capa.byte * (ullint)capa.lba;
				printf( "Unit capacity                   : %Ld MBytes  %Ld Bytes\n" ,
						size64>>20, size64 );
				puts( bar2 );
			}
			else
			{
				if(inq.DeviceType != 0)					// direct access
					if(inq.DeviceType != 5)				// CD-ROM
						if(inq.DeviceType != 7)			// MO
							if(inq.DeviceType != 0x10)	// MD
								error_exit( "whc̃foCX̓eXgo܂B" );

				if( check_result(S_READCAP( TargetID , &capa )) != 0 )
					error_exit("failed:READ CAPACITY");
				LbaMax   = capa.lba;
				SectSize = capa.byte;
				if(SectSize != 256)
					if(SectSize != 512)
						if(SectSize != 1024)
							if(SectSize != 2048)
								error_exit( "ubNTCYT|[g͈͊OłB" );

				printf( "  Initiator is ID%d     : SHARP   %s%04X  %s\n" , SPC_ID , machine_name , SCSIver, SCSIPort[PortType] );
				tbf[DISP_SIZE] = '\0';
				memcpy( tbf , inq.VendorID , DISP_SIZE );
				printf( "  Target device is ID%d : %s  %s %s\n" , TargetID , tbf, inq.ANSI_Ver <= 3 ? ANSI_VS[inq.ANSI_Ver] : "Unknown", inq.RMB >> 7 ? "Removable" : "" );
				size64 = (ullint)SectSize * (ullint)(LbaMax+1) / (ullint)0x100000;
				printf( "  %d Bytes per sector, capacity is %Ld MBytes.\n" ,
							SectSize , size64 );
				puts( bar );
				puts( "        Test mode       :    result   |  Poor |   OK  |  Good | Great | Superb|" );
				CommandBench();
				SeekBench();
				ReadBench();
				puts( bar );
			}
		}
	}
}
